<?
/**
 * @file fileo.inc
 * @author Akash Heimlich
 * @version 1.0
 * @date 24/06/2019
 * @description File I/O functions
 */
 
/**
  * Get a string of arbitratry length from a file handle
  *
  * Since uPHP has a maximum length of 255 bytes for strings read from disk, 
  * this function checks for the condition and keeps reading till the end of 
  * the string.
  *
  * @param file $f is the file handle
  *
  * @return string String containing date from file
  */ 
function fgets_long($f) {
    $headers=fgets($f);
    
    if (strlen($headers)==254) {
        $st2=$headers;
        while (strlen($st2)==254) {
            $st2=fgets($f);
            $headers.=$st2;//$st2='';
        }
    }
    return $headers;
}

?>



